#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>
#include <string.h>
#include <pwd.h>
#include <signal.h>

#include "sockdefs.h"
#include "datah.h"

/* replace yournick in CONTROL_NICK to the nickname of the person who is
going to control the bot */
#define CURRENT_CAT_STRING "The category for"
#define CONTROL_NICK ":yournick!"

void print_answers(int sock,struct topicnode *tptr);
typedef void (*sighandler_t)(int);
sighandler_t signal(int signum, sighandler_t handler);

FILE *outf;
char current_topic[50];
char localhost[80];
char nickname[20];
char servername[80];
char username[20];
char realname[80];
struct hashnode hash_table[89];
struct topicnode *tptr;

struct hostent *hp, *gethostbyname();
int inround;
int getting_answers;

void handle_socket(int in_sock)
{
struct timeval to;
fd_set rread;
int socketopen=1;
int sr,rval;
int ret;
char * buff;
char * buf;
char * partial;

partial=(char *)malloc(2000*sizeof(char));
if (partial==NULL){return;}
buf=(char *)malloc(300*sizeof(char));
if (buf==NULL){return;}

strcpy(partial,"");
do {
FD_ZERO(&rread);
FD_SET(in_sock,&rread);
memset((char *)&to,0,sizeof(to));
to.tv_sec=5;
sr=select(in_sock+1, &rread, (fd_set *)0, (fd_set *)0, &to);
 
if (sr < 0) {
        perror("select");
        continue;
}
/*printf("sr=%i\n",sr);
fflush(stdout);
*/
if (sr> 0)
{
to.tv_sec=0;
if (FD_ISSET(in_sock,&rread))
{
/*printf("reading inbound\n");fflush(stdout);*/
/* read the message from inbound socket */
if ((rval=read(in_sock,buf,200)) <= 0)
	{
        	printf ("ending connection\n");
        	socketopen=0;       
	}
        else {  buf[rval]=0;
                /*printf("INPUT-->%s**END**\n\n",buf);*/
		strcat(partial,buf);
		strcpy(buf,partial);
		if (strstr(buf,"\r\n")!=NULL)
			{
			buff=strtok(buf,"\n");
			while(buff!=NULL)
			{
				/*printf("buff=>%s",buff);*/
				if (strstr(buff,"\r")!=NULL)
				{
				ret=parse_message(in_sock,buff);
				}
				strcpy(partial,buff);
				if (ret==1) {ping_back(in_sock);}
			buff=strtok(NULL,"\n");
		  	}
			}
		
		if (strstr(partial,"\r")!=NULL)
			{
/*
			printf("COMPLETE LINE.\n");
*/
			strcpy(partial,"");
			}
		else
			{
/*
			printf("INCOMPLETE LINE.\n");
*/
			}

               /* write_sock(out_sock,buf,rval);*/
                }
}
 
}
} while (socketopen);
free(buf);
free(partial);
}

char * remove_non_ascii(char *buf)
{
char clean[255];
int i=0;

while (*buf!=0)
  {
/*
	if (*buf>32 && *buf<126) {clean[i]=*buf;i++;}
*/
	if (isalpha(*buf))  
	{
		clean[i]=*buf;
		i++;
	}
 	
  *buf++;
 }
clean[i]=0;
return(strdup(clean));
}

char * find_longest_word(char * buf)
{
char ln[500];
char oldword[500];
char * word;
strcpy(ln,buf);
if (word=strtok(ln," "))
{
	strcpy(oldword,word);
	while (word=strtok(NULL," "))
	{
	if (strlen(word)>strlen(oldword))
		strcpy(oldword,word);
	}
}
return (strdup(oldword));
}

int parse_chaosbot_message(int sock,char *mess)
{
char category[100];
char answer[100];
char junk[200];
int num,i;
char *pmess;
struct answernode *nans;
char * stripped;
char * long_word;

if (strncasecmp(mess,"Starting a new round.",21)==0)
	{printf("*****STARTING NEW ROUND*****\n\n");
	 inround=1;
	}
else if(strncasecmp(mess,"- Time is up!",13)==0)
	{
	printf("*****ENDING ROUND*****\n\n");
	inround=0;
	talk_to_channel(sock);
	if (strcmp(current_topic,"UNKNOWN")!=0)
	{	
	getting_answers=1;
	fprintf(outf,"*%s\n",current_topic);
	}
	}
else if(strncasecmp(mess,CURRENT_CAT_STRING,strlen(CURRENT_CAT_STRING))==0)
	{
	pmess=strchr(mess,':');
	if (pmess!=NULL)
	{
	    pmess++;
	    pmess++;
 	}
	long_word=find_longest_word(pmess);
	stripped=remove_non_ascii(long_word);	
	free(long_word);
	strcpy(category,stripped);
	free(stripped);
/* If there is a space left in the line then we are being tricked */

	printf("*****CURRENT CAT=%s*******\n\n",category);
	fflush(stdout);
	strcpy(current_topic,category);
	tptr=find_topic(current_topic);
	if (tptr!=NULL)
		{
			printf("!!!!!I KNOW THIS TOPIC!!!!!!!\n");
			fflush(stdout);
			print_answers(sock,tptr);
			fflush(stdout);
			talk_to_channel(sock);
		}
	else
		{
			printf("UNKNOWN NEW TOPIC\n");
			fflush(stdout);
		        tptr=make_new_topic(current_topic);
		        insert_new_topic(current_topic,tptr);
		}	
	}
else if(getting_answers)
	{
			if (mess[0]<48||mess[0]>57) {
			fprintf(outf,"*ENDA\n");
			 fflush(outf);
                        getting_answers=0;
                        strcpy(current_topic,"UNKNOWN");
			return;
                        }
/*
	sscanf(mess,"%d : %[^.]%s",&num,answer,junk);*/
	sscanf(mess,"%d : %[^:]%s",&num,answer,junk);
	
 	pmess=strrchr(answer,'.');
	if (pmess!=NULL){
	        *pmess=0;
		
	}
	i=0;
	while (answer[i]!='('&&answer[i]!=0)
		{junk[i]=answer[i];i++;}
	if (i>0&&answer[i]=='('){i--;}
	junk[i]=0;
	strcpy(answer,junk);
       	/*strcpy(answer,pmess);*/
	if (tptr!=NULL)
	{
	nans=find_answer(answer,tptr);
	if (nans==NULL){	
	nans=make_new_answer(answer);
	insert_answer(answer,tptr,nans);
	fprintf(outf,"%s\n",answer);
	}
	}
	if (num==9){ 	fprintf(outf,"*ENDA\n");	
			fflush(outf);
			getting_answers=0;
			strcpy(current_topic,"UNKNOWN");
			tptr=NULL;
			talk_to_channel(sock);
			}	
 	printf("*****ANSWER %d IS:%s*****\n\n",num,answer);	
	fflush(stdout);
	}

else if(strncasecmp(mess,"Welcome to Chaos!",strlen("Welcome to Chaos!"))==0)
	{
	printf("*****NEW GAME STARTING***\n\n");
 	return 2;	
	}


}

void print_answers(int sock,struct topicnode *tptr)
{
char myans[100];
struct answernode *aptr;
int rn;

aptr=tptr->answerlist;

while (aptr!=NULL)
        {
                printf("MY GUESS IS: %s\n",aptr->ans);
		strcpy(myans,"cb ");
		strcat(myans,aptr->ans);
                send_to_channel(sock,"#chaos",myans); 
                aptr=aptr->next_answer;
		rn=(rand()%1)+3;
		printf("sleeping for %d\n",rn);
		fflush(stdout);
		sleep(rn);
        }

}

void ping_back(int sock)
{
char comm[200];
/*printf("******PONGING****\n");
fflush(stdout);*/
sprintf(comm,"PONG %s %s",nickname,servername);
writeout(sock,comm);
}

void join_game(int sock)
{
send_to_channel(sock,"#chaos","cb join team 1");
}


int parse_message(int sock,char *msg)
{
char from[100];
char action[100];
char to[100];
char mess[255];
char *pmess;
int i;


sscanf(msg,"%s %s %s :%[^\n]",from,action,to,mess);
if (strncasecmp(from,":chaosbot!",strlen(":chaosbot!"))==0)
	{
		i=0;	
		while ((mess[i]<33||mess[i]>126)&&i<255){
				i++;
				}
		pmess=&mess[i]; 
		/*printf("MESSAGE FROM BOT:%s\n",pmess);*/
		i=parse_chaosbot_message(sock,pmess);
		if (i==2) {join_game(sock);}
	}
else if(strncasecmp(msg,"PING ",5)==0)
	{
		/*printf("**GOT PING**\n");*/
		return 1;
	}
else if(strncasecmp(from,CONTROL_NICK,strlen(CONTROL_NICK))==0)
	{/*	printf("msg=%s\n",msg);
		fflush(stdout);*/
		if (strncasecmp(to,nickname,strlen(nickname))==0)
		{
		send_to_channel(sock,"#chaos",mess);
		}
	}

return 0;

}


void writeout(int sock,char * buf)
{
char bbuf[500];
strcpy(bbuf,buf);
strcat(bbuf,"\n\r");
write_sock(sock,bbuf,strlen(bbuf));
}

void send_to_channel(int sock,char * channel,char * msg)
{
char mess[500];
sprintf(mess,"PRIVMSG %s :%s",channel,msg);
writeout(sock,mess);
}

void log_into_server(int sock)
{
char comm[200];
sprintf(comm,"NICK %s",nickname);
writeout(sock,comm);
sprintf(comm,"USER %s %s %s :%s",username,localhost,localhost,realname);
writeout(sock,comm);
writeout(sock,"JOIN #chaos");
}

void write_sock(int sock,char *buf,int len)
{
 
send(sock,buf,len,0);
 
}


void talk_to_channel(int sock)
{

int i,rn;
char resp[100];

FILE *mf;
mf=fopen("responses.dat","r");
if (mf==NULL){return;}

rn=rand()%75;
if (rn>67){strcpy(resp,":-)");}
else
{
i=0;
while (!feof(mf)&&i<rn)
{
	fgets(resp,100,mf);
	i++;	
}
if (!feof(mf)) {fgets(resp,100,mf);}
else {strcpy(resp,":-)");}
}
fclose(mf);
/*send_to_channel(sock,"#chaos",resp);*/
}

void signal_handler(int sig)
{
printf("\nGOT SIGNAL! - FLUSHING...\n");
fflush(stdout);
fflush(outf);

}

main(int argc, char *argv[])
{
struct sockaddr_in server;
char DATA[1024];
char rcommand[100],fname[255];
char port[8];
int csock;
int sockaddr_size;
char * localip;
struct passwd *passent;

signal(SIGHUP,signal_handler);
passent=getpwuid(getuid());
strcpy(nickname,passent->pw_name);
strcpy(username,passent->pw_name);
strcpy(realname,passent->pw_gecos);
srand(time(NULL)); 
outf=fopen("qna.dat","r");
setup_hash_table(outf);
fclose(outf);
outf=fopen("qna.dat","a");
inround=0;
getting_answers=0;
tptr=NULL;
strcpy(current_topic,"UNKNOWN");
if (argc>1) {
		strcpy(servername,argv[1]);
		strcpy(port,argv[2]);
	   }
else 	{
		strcpy(servername,"irc.gate.net");
                strcpy(port,"6666");
	} 
csock=socket(AF_INET,SOCK_STREAM,0);
if (csock<0) {
        perror("opening stream socket");
        exit(1);
}
 
server.sin_family=AF_INET;
hp=gethostbyname(servername);
if (hp==0) {
        fprintf(stderr,"%s: unknown host",servername);
        exit(2);
}
 
memcpy((char *)&server.sin_addr,(char
*)hp->h_addr,hp->h_length);
server.sin_port=htons(atoi(port));

printf("Connecting to %s (%s) on port %s...\n",servername,inet_ntoa(server.sin_addr),port); 
fflush(stdout);
if (connect(csock,(struct sockaddr *)&server, sizeof server)<0) {
        perror("Connecting stream socket");
        exit(1);
}
printf("Connected.\n");
fflush(stdout);
sockaddr_size=sizeof server;
if (getsockname(csock,(struct sockaddr *)&server,&sockaddr_size)==-1)
	{
	fprintf(stderr,"Cannot get local hostname");
	exit(2);
	}

localip=(char *)&server.sin_addr;

strcpy(localhost,(char *)inet_ntoa(server.sin_addr));
printf("Local IP is %s\n",inet_ntoa(server.sin_addr));
printf("Local username is %s.\n",username);
printf("Local nickname is %s.\n",nickname);
printf("Local realname is %s.\n",realname);
fflush(stdout);
printf("Logging into server...\n");
log_into_server(csock);
printf("Logged in.\n");
printf("Joining game.\n");
join_game(csock);
printf("Joined game.\n");
fflush(stdout);
talk_to_channel(csock);
handle_socket(csock);
 
close(csock);
fclose(outf);
free_hash_table();
printf("Exiting...\n");
exit(0);
}

