#include <string.h>
#include <stdio.h>
#include "datah.h"


extern struct hashnode hash_table[26];

void free_hash_table()
{
int i;

for (i=0;i<76;i++)
{
	/*printf("Freeing list #%d\n",i);*/
	free_list(hash_table[i].topiclist);
}

}

int setup_hash_table(FILE *df)
{
int i;
int numtopics,numanswers;
char ctopic[100];
char ans[100];
struct topicnode *pcurtopic;
struct answernode *pcurans;
int endofanswers;
printf("ChaosKiller 1.0a\nWritten By: sourcecode@geocities.com\n");
printf("1) Setting up hash table...\n");
for (i=0;i<76;i++)
	{
	hash_table[i].topiclist=NULL;
	}
printf("1) Done.\n");
if (df==NULL){return;}
printf("2) Inserting data into table...\n");
fgets(ctopic,100,df);
numtopics=0;
numanswers=0;
while (!feof(df)) {
/*printf("LOADING TOPIC %s...\n",ctopic);*/
pcurtopic=find_topic(&ctopic[1]);
if (pcurtopic==NULL)
{
pcurtopic=make_new_topic(&ctopic[1]);
insert_new_topic(&ctopic[1],pcurtopic);
numtopics++;
}
endofanswers=0;
i=0;
do {
	fgets(ans,100,df);
/*	printf("ANSWER #%d=%s\n",i,ans);*/
	if (ans[0]=='*'){endofanswers=1;}
	/*if (strncmp(ans,"*ENDA",4)==0){endofanswers=1;}*/	
	else {pcurans=make_new_answer(ans);
		insert_answer(ans,pcurtopic,pcurans);i++;numanswers++;}

   }while (!endofanswers&&!feof(df));
fgets(ctopic,100,df);
}

printf("2) Done.\n");
/*
for (i=0;i<89;i++)
        {
        printf("Traversing hash table %c\n",i+'0');
        traverse(hash_table[i].topiclist);
        }
*/
printf("I know %d categories.\n",numtopics);
printf("I know %d answers.\n",numanswers);
fflush(stdout);
return 1;
}

void traverse(struct topicnode *tp) 
{
struct answernode *ca;

while (tp!=NULL)
	{
/*
	printf("TOPIC IS %s\n",tp->topic_name);*/
	/*printf("ANSWERS ARE:\n");*/
	ca=tp->answerlist;
	while (ca!=NULL)
	{
	/*printf("----%s",ca->ans);*/
	ca=ca->next_answer;
	}
	tp=tp->next_topic;
	}
}

void free_list(struct topicnode *tp)
{

struct answernode *ca, *nxtca;
struct topicnode *nxttp;
while (tp!=NULL)
{
	ca=tp->answerlist;
	while (ca!=NULL)
	{
	nxtca=ca->next_answer;
	free(ca);
	ca=nxtca;
	}

	nxttp=tp->next_topic;
	free(tp);
	tp=nxttp;
}
}

struct answernode * make_new_answer(char * ans)
{
struct answernode *nans;
nans=(struct answernode *)malloc(sizeof(struct answernode));
if (nans==NULL) {printf("OUT OF MEMORY!\n");fflush(stdout);return;}
strcpy(nans->ans,ans);
nans->next_answer=NULL;
return nans;
}

struct topicnode * make_new_topic(char * topic)
{
struct topicnode *nt;

nt=(struct topicnode *)malloc(sizeof(struct topicnode));
if (nt==NULL) {printf("OUT OF MEMORY!\n");fflush(stdout);return;}
strcpy(nt->topic_name,topic);
nt->answerlist=NULL;
nt->next_topic=NULL;

return nt;
}

void insert_new_topic(char * topic, struct topicnode *nt)
{
char ind;
struct topicnode *oldptr;

ind=topic[0];
/*printf("Index character=%c\n",ind);*/

oldptr=hash_table[ind-'!'].topiclist;
nt->next_topic=oldptr;
hash_table[ind-'!'].topiclist=nt;
}

void insert_answer(char *ans,struct topicnode * ptopic,struct answernode *nans)
{
struct answernode *oldptr;
if (ptopic==NULL||nans==NULL){printf("INSERT ANSWER ERROR!\n");fflush(stdout);return;}
oldptr=ptopic->answerlist;
ptopic->answerlist=nans;
nans->next_answer=oldptr;

}

struct topicnode * find_topic(char * topic)
{
char ind;
struct topicnode *tptr;
ind=topic[0];
/*printf("Index character=%c\n",ind);*/

tptr=hash_table[ind-'!'].topiclist;
while (tptr!=NULL&&(strncasecmp(topic,tptr->topic_name,strlen(topic))!=0))
	{
/*	printf("COMPARING %s\n",tptr->topic_name);*/
	tptr=tptr->next_topic;
	}
return tptr;
}

struct answernode * find_answer(char *answer, struct topicnode *tptr)
{

struct answernode * aptr;

aptr=tptr->answerlist;

while (aptr!=NULL&&(strncmp(answer,aptr->ans,strlen(answer))!=0))
	{
/*	printf("COMPARING ANSWER %s\n",aptr->ans);*/
	aptr=aptr->next_answer;
	}
return aptr;
}


